function varargout = nodal(varargin)
% NODAL MATLAB code for nodal.fig
%      NODAL, by itself, creates a new NODAL or raises the existing
%      singleton*.
%
%      H = NODAL returns the handle to a new NODAL or the handle to
%      the existing singleton*.
%
%      NODAL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NODAL.M with the given input arguments.
%
%      NODAL('Property','Value',...) creates a new NODAL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before nodal_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to nodal_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help nodal

% Last Modified by GUIDE v2.5 09-Mar-2013 20:37:09
% User-defined input last revised by JDJ, 03-05-17

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @nodal_OpeningFcn, ...
                   'gui_OutputFcn',  @nodal_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before nodal is made visible.
function nodal_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to nodal (see VARARGIN)

% Compute initial upstream and downstream pressure drop:
warning off
global results_us results_ds;
p_R        = 20e6; % reservoir pressure, Pa
p_sep      = 0.5e6; % separator pressure, Pa
results_us = system_01_upstream_GUI(p_R); % computes upstream pressure drop
results_ds = system_01_downstream_GUI(p_sep); % computes downstream pressure drop
plot(results_us(:,1),results_us(:,2)/1e6,'LineWidth',2);
hold on
plot(results_ds(:,1),results_ds(:,2)/1e6,'-r','LineWidth',2);
hold off
xlabel('Oil flow rate\it -q_{o,sc} ,\rm m^3/s','FontSize',12)
ylabel('Flowing tubing head pr. \it p_{tf} ,\rm MPa','FontSize',12)
text(-0.88e-3,3.07,'\it p_{sep}','FontSize',12)
text(-2.34e-3,2.4,'Separator pressure \it p_{sep}','FontSize',12)
text(-1.81e-3,0.62,'\it p_R','FontSize',12)
text(-2.34e-3,1.70,'Reservoir pressure \it p_R','FontSize',12)
text(-3.85e-3,3.07,'\it p_{tf}','FontSize',12)
text(-1.17e-3,0.64,['\bfNo flow'],'FontSize',12)
box on
grid on
axis([0 2.5e-3 0.5 3.5])
legend('Upstream','Downstream','Location','NorthEast')
value_p_sep = num2str(p_sep/1e6,'%4.2f');
set(handles.text11,'String',value_p_sep)
value_p_R = num2str(p_R/1e6,'%3.1f');
set(handles.text13,'String',value_p_R)

% Draw system figure:
ar = 11/20; % aspect ratio plot 
shift = 0.02; % shift of plot
annotation('ellipse',[0.474-shift 0.731 0.01*11/20 0.01],'LineWidth',7)
annotation('line',[0.43-shift 0.47-shift],[0.735 0.735],'LineWidth',2)
annotation('rectangle',[0.28-shift 0.685 0.15 0.1],'LineWidth',2) 
annotation('line',[0.24-shift 0.28-shift],[0.735 0.735],'LineWidth',2)
annotation('ellipse',[0.234-shift 0.731 0.01*11/20 0.01],'LineWidth',7)
annotation('arrow',[0.23-shift 0.17-shift],[0.735 0.735],'LineWidth',2,'HeadStyle','plain',...
    'HeadWidth',20,'HeadLength',20)
annotation('arrow',[0.11-shift 0.17-shift],[0.735 0.735],'LineWidth',2,'HeadStyle','plain',...
    'HeadWidth',20,'HeadLength',20)
annotation('ellipse',[0.097-shift 0.725 0.02*ar 0.02],'LineWidth',3)
annotation('line',[0.103-shift 0.103-shift],[0.30+0.15/ar 0.45+0.15/ar],'LineWidth',2)
annotation('rectangle',[0.103-0.05*ar-shift 0.30 0.1*ar 0.15/ar],'LineWidth',2) 
annotation('line',[0.103-shift 0.103-shift],[0.15 0.30],'LineWidth',2)
annotation('ellipse',[0.10-shift 0.145 0.01*11/20 0.01],'LineWidth',7)
annotation('line',[0.10-shift 0.15-shift],[0.15 0.15],'LineWidth',2)
annotation('rectangle',[0.15-shift 0.1 0.15 0.1],'LineWidth',2) 
annotation('line',[0.30-shift 0.35-0.01*ar-shift],[0.15 0.15],'LineWidth',2)
annotation('ellipse',[0.35-0.01*ar-shift 0.145 0.01*ar 0.01],'LineWidth',7)
warning on

% Choose default command line output for nodal
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes nodal wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = nodal_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on slider movement.
function slider2_Callback(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

% Compute downstream pressure drop:
warning off
global results_us results_ds;
p_sep_min     = 5e5; % minimum separator pressure, Pa 
p_sep_max     = 10e5; % maximum separator pressure, Pa 
slider_value  = get(hObject,'Value');
p_sep = p_sep_min + slider_value * (p_sep_max - p_sep_min); % separator pressure, Pa
results_ds = system_01_downstream_GUI(p_sep); % computes downstream pressure drop
% Compute intersection:
difference = fit(results_us(:,1),results_us(:,2)-results_ds(:,2),'linearinterp');
options.Display = 'off';
[q_o_sc,~,exitflag] = fzero(difference,1e-3,options);
results_us_fit = fit(results_us(:,1),results_us(:,2),'linearinterp'); 
p_tf = results_us_fit(q_o_sc);
% Plot:
value_p_sep = num2str(p_sep/1e6,'%4.2f');
set(handles.text11,'String',value_p_sep)
plot(results_us(:,1),results_us(:,2)/1e6,'LineWidth',2);
hold on
plot(results_ds(:,1),results_ds(:,2)/1e6,'-r','LineWidth',2);
grid on
text(-0.88e-3,3.07,'\it p_{sep}','FontSize',12)
text(-2.34e-3,2.4,'Separator pressure \it p_{sep}','FontSize',12)
text(-1.81e-3,0.62,'\it p_R','FontSize',12)
text(-2.34e-3,1.70,'Reservoir pressure \it p_R','FontSize',12)
text(-3.85e-3,3.07,'\it p_{tf}','FontSize',12)
if exitflag > 0 % intersection present 
    value_p_tf = num2str(p_tf/1e6,'%4.2f');
    value_q_o_sc = num2str(q_o_sc*1e3,'%4.2f');
    text(-1.51e-3,0.74,['\bf\it q_{o,sc} = \rm\bf',value_q_o_sc,' \times 10^{-3} m^3/s'],'FontSize',12)
    text(-1.39e-3,0.54,['\bf\it p_{tf} = \rm\bf',value_p_tf,' MPa'],'FontSize',12)
    plot(q_o_sc,p_tf/1e6,'o','MarkerSize',6,'MarkerEdgeColor','k','MarkerFaceColor','k')
    plot([q_o_sc q_o_sc],[0.5 p_tf/1e6],'-k','LineWidth',1)
    plot([0 q_o_sc],[p_tf/1e6 p_tf/1e6],'-k','LineWidth',1)
else
    text(-1.17e-3,0.64,['\bfNo flow'],'FontSize',12)
end
hold off
legend('Upstream','Downstream','Location','NorthEast')
axis([0 2.5e-3 0.5 3.5])
xlabel('Oil flow rate\it -q_{o,sc} ,\rm m^3/s','FontSize',12)
ylabel('Flowing tubing head pr. \it p_{tf} ,\rm MPa','FontSize',12)
warning on

% --- Executes during object creation, after setting all properties.
function slider2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
% get(hObject,'Min')
% get(hObject,'Max')

% Compute upstream pressure drop:
warning off
global results_us results_ds;
p_R_min      = 20e6; % minimum reservoir pressure, Pa 
p_R_max      = 25e6; % maximum reservoir pressure, Pa 
slider_value = get(hObject,'Value');
p_R          = p_R_min + slider_value * (p_R_max - p_R_min); % reservoir pressure, Pa
results_us = system_01_upstream_GUI(p_R); % computes upstream pressure drop
% Compute intersection:
difference = fit(results_us(:,1),results_us(:,2)-results_ds(:,2),'linearinterp');
options.Display = 'off';
[q_o_sc,~,exitflag] = fzero(difference,1e-3,options);
results_us_fit = fit(results_us(:,1),results_us(:,2),'linearinterp'); 
p_tf = results_us_fit(q_o_sc);
% Plot:
value_p_R = num2str(p_R/1e6,'%3.1f');
set(handles.text13,'String',value_p_R)
plot(results_us(:,1),results_us(:,2)/1e6,'LineWidth',2);
hold on
plot(results_ds(:,1),results_ds(:,2)/1e6,'-r','LineWidth',2);
grid on
text(-0.88e-3,3.07,'\it p_{sep}','FontSize',12)
text(-2.34e-3,2.4,'Separator pressure \it p_{sep}','FontSize',12)
text(-1.81e-3,0.62,'\it p_R','FontSize',12)
text(-2.34e-3,1.70,'Reservoir pressure \it p_R','FontSize',12)
text(-3.85e-3,3.07,'\it p_{tf}','FontSize',12)
if exitflag > 0 % intersection present 
    value_p_tf = num2str(p_tf/1e6,'%4.2f');
    value_q_o_sc = num2str(q_o_sc*1e3,'%4.2f');
    text(-1.51e-3,0.74,['\bf\it q_{o,sc} = \rm\bf',value_q_o_sc,' \times 10^{-3} m^3/s'],'FontSize',12)
    text(-1.39e-3,0.54,['\bf\it p_{tf} = \rm\bf',value_p_tf,' MPa'],'FontSize',12)
    plot(q_o_sc,p_tf/1e6,'o','MarkerSize',6,'MarkerEdgeColor','k','MarkerFaceColor','k')
    plot([q_o_sc q_o_sc],[0.5 p_tf/1e6],'-k','LineWidth',1)
    plot([0 q_o_sc],[p_tf/1e6 p_tf/1e6],'-k','LineWidth',1)
else
    text(-1.17e-3,0.64,['\bfNo flow'],'FontSize',12)
end
hold off
legend('Upstream','Downstream','Location','NorthEast')
axis([0 2.5e-3 0.5 3.5])
xlabel('Oil flow rate\it -q_{o,sc} ,\rm m^3/s','FontSize',12)
ylabel('Flowing tubing head pr. \it p_{tf} ,\rm MPa','FontSize',12)
warning on

% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

hold off
