function N_Re = Reynolds_number(d,mu,rho,q)
% function N_Re = Reynolds_number(d,mu,rho,q)
%
% d = diameter, m
% mu = kinematic vicosity, Pa s
% N_Re = Reynolds number, -
% rho = density, kg/m^3
% q = flow rate, m^3/s
%
% JDJ, 12-02-02, last revised 10-05-13

N_Re = 4*rho*abs(q) / (pi*mu*d);