% Script file answer_question_3_10
%
% JDJ, 20-03-03, last revised 07-01-16

clear variables
close all

% Input data:
alpha = 0; % wellbore inclination , rad
d = 0.062; % tubing inside diameter, m 
e = 30e-6; % tubing roughness, m
fluid = 2 % single-phase gas flow
oil = 1; % dummy, not relevant for gas flow but needed for pipe.m
p_wf = 2.9e+7; % FBHP, Pa.
q_g_sc = -8.61; % gas rate, m^3/s.
q_o_sc = 0; % dummy
q_w_sc = 0;% dummy
rho_g_sc = 0.95; % gas density at standard conditions, kg/m^3.
rho_o_sc = 850;  % dummy
rho_w_sc = 1000; % dummy
s_tot = 3000; % total along-hole well depth, m 
T_tf = 30; % flowing tubing head temperature, deg. C
T_wf = 120; % flowing bottom hole temperature, deg. C

% Compute input vectors:
q_sc = [q_g_sc,q_o_sc,q_w_sc];
rho_sc = [rho_g_sc,rho_o_sc,rho_w_sc];
% Store the FBHP:
p_wf_old = p_wf;
% Compute the FTHP for known FBHP:
p_tf = pipe(alpha,d,e,fluid,oil,p_wf,q_sc,rho_sc,s_tot,0,T_wf,T_tf)
% Re-compute the FBHP for known FTHP: 
p_wf = pipe(alpha,d,e,fluid,oil,p_tf,q_sc,rho_sc,0,s_tot,T_tf,T_wf)
% Determine absolute and relative errors:
delta_p = p_wf-p_tf
error_abs_p_wf = p_wf-p_wf_old
error_rel_p_wf = error_abs_p_wf/delta_p
