% Script file answer_question_3_9
%
% JDJ, 20-03-03, last revised 07-01-16
%

clear variables
close all

% Input data:
d = 0.232; % flowline inside diameter, m 
e = 3e-6; % flowline roughness, m
fluid = 1 % single-phase oil flow
oil = 1; % black oil; parameters computed with the aid of Standing correlations
p_fl = 10.0e5 % manifold pressure, Pa
q_g_sc = 0; % dummy
q_o_sc = -5000/(24*3600); % oil rate, m^3/s. Note conversion to m^3/s! 
q_w_sc = 0;% dummy
% Note: flow rates should have negative values for a production well!
rho_g_sc = 0.95; % dummy
rho_o_sc = 850;  % oil density at standard conditions, kg/m^3
rho_w_sc = 1000; % dummy
s_tot = 3000; % total flow line length, m
theta = from_deg_to_rad(-1.5); % flowline inclination wrt. horizontal, rad; a positive value
% indicates an increasing flow line elevation, seen from the manifold     
T_fl = 45; % flow line temperature at the well head, deg. C
T_mf = 45; % manifold temperature, deg. C

% Convert from pipeline inclination to well bore inclination:
alpha = from_theta_to_alpha(theta);

% Compute the manifold pressure by integrating from s_tot to 0:
q_sc = [q_g_sc,q_o_sc,q_w_sc];
rho_sc = [rho_g_sc,rho_o_sc,rho_w_sc];
p_mf = pipe(alpha,d,e,fluid,oil,p_fl,q_sc,rho_sc,s_tot,0,T_fl,T_mf)
