% Script file answer_question_5_13
%
% JDJ, 21-10-13, last revised 07-01-16
%

clear variables
close all

% Input data:
C_d = 0.9; % discharge coefficient, -
c_l = 0.82; % specific heat capacity of liquid at constant volume, J/(kg K)
c_p = 0.26; % specific heat capacity of gas at constant pressure, J/(kg K)
c_v = 0.20; % specific heat capacity of gas at constant volume, J/(kg K)
d_ch = 0.0127; % choke diameter, m
q_o_sc = -120/(24*3600); % oil rate, m^3/s
f_w_sc = 0.70; % water cut, -
R_go = 40; % gas-oil ratio as observed at surface, m^3/m^3
p_4 = 1.2e6; % down-stream pressure, Pa
T_1 = 50; % upstream temperature, deg. C
rho_g_sc = 0.87; 
rho_o_sc = 865;
rho_w_sc = 1030;

% Compute auxiliary variables:
q_g_sc = R_go * q_o_sc;
q_w_sc = (f_w_sc/(1-f_w_sc)) * q_o_sc;
q_sc = [q_g_sc,q_o_sc,q_w_sc];
rho_sc = [rho_g_sc,rho_o_sc,rho_w_sc];

% Compute upstream pressure and pressure ratios:
choke_model = 1; % Gilbert correlation 
p_1 = choke_multi_phase_simp(choke_model,d_ch,p_4,q_sc);
disp(sprintf('\nupstream pressure from choke_multi_phase_simp: %g', p_1)); 
oil = 1; % black oil; parameters computed with the aid of Standing correlations
[p_1,r_crit] = choke_multi_phase(C_d,c_l,c_p,c_v,d_ch,oil,p_4,q_sc,rho_sc,T_1);
disp(sprintf('\nupstream pressure from choke_multi_phase: %g', p_1));
disp(sprintf('\ncritical flow boundary (p_4/p_1)_crit from choke_multi_phase: %g', r_crit)); 
disp(sprintf('\np_4/p_1 from choke_multi_phase: %g', p_4/p_1)); 
disp(sprintf('\ncritical flow boundary (p_1/p_4)_crit from choke_multi_phase: %g', 1/r_crit)); 
disp(sprintf('\np_1/p_4 from choke_multi_phase: %g', p_1/p_4)); 

