% Script file answer_question_6_11
%
% JDJ, 25-10-13, last revised 07-01-16

clear variables
close all

% Input data:
av = 1; % use average reservoir pressure
h = from_ft_to_m(35); % reservoir height, m
k_o = from_mD_to_m2(84); % effective permeability to oil, m^2
oil = 1; % black oil; parameters computed with the aid of Standing correlations
p_in = from_psi_to_Pa(5600); % average reservoir pressure p_R_av, Pa
r_in = from_ft_to_m(2100); % reservoir radius, m
r_out = from_ft_to_m(0.33); % well bore radius, m
R_sb = from_ft3_per_bbl_to_m3_per_m3(145); % solution GOR at bubble point, m^3/m^3 
q_o_sc = -1e-3; % oil flow rate (arbitrary small number), m^3/s
q_g_sc = R_sb * q_o_sc; % gas flow rate, m^3/s
q_w_sc = 0; % water flow rate, m^3/s
q_sc = [q_g_sc, q_o_sc, q_w_sc]; 
rho_g_sc = from_gas_grav_to_kg_per_m3(0.78); % gas density, kg/m^3
rho_o_sc = from_deg_API_to_kg_per_m3(29); % oil density, kg/m^3
rho_w_sc = 1030; % water density; not relevant, kg/m^3 
rho_sc = [rho_g_sc, rho_o_sc, rho_w_sc];
semi = 1; % use semi-steady-state conditions
S = 0; % skin, -
T_R = from_deg_F_to_deg_C(230); % reservoir temperature, deg. C

% Compute PI:
[~,~,~,J] = res_oil_simp(av,h,k_o,oil,p_in,q_sc,r_in,r_out,rho_sc,semi,S,T_R) % in SI units
J_fu = from_m3_per_s_Pa_to_bpd_psi(J) % in field units
