% script file answer_question_6_13
%
% Modified version of example_gas_pseu_pres.m
%
% Computes and plots the real gas pseudo pressure as a function of pressure. Creates a table
% (i.e. two vectors, p and m) which can be used to compute the pseudo pressure m(p) using
% interpolation: m_i = interp1(p,m,p_i), where p_i is a given pressure and m_i the
% corresponding (to be computed) pseudo pressure. 
%
% JDJ, 27-10-13, last revised 07-01-16

clear variables
close all

% Input data:
p_max = 40e6; % maximum pressure (upper limit integration), Pa 
p_ref = 0.1e6; % reference pressure (lower limit integration), Pa
rho_g_sc = 0.95; % gas density at standard conditions, kg/m^3 
T = 120; % temperature, deg. C

% Compute table:
[p m] = gas_pseu_pres(p_max,p_ref,rho_g_sc,T);

% Compute pseudo pressures through interpolation:
p_wf = 20e6 % FBHP, Pa
m_wf = interp1(p,m,p_wf) % corresponding pseudo pressure, Pa
p_R = 40e6 % reservoir pressure, Pa
m_R = interp1(p,m,p_R) % corresponding pseudo pressure, Pa

% Compute mu_ref and B_ref:
mu_g_ref = gas_viscosity(p_ref,rho_g_sc,T)
B_g_ref = gas_form_vol_fact_direct(p_ref,rho_g_sc,T+273.15)
