function beta = Forcheimer(k)
% function beta = Forcheimer(k)
%
% Computes the Forcheimer coefficient for a given permeability.
%
% A = coefficient, m^(2*B-1)
% B = coefficient, -
% beta = Forchheimer coefficient, m^-1
% k = permeability
% 
% Reference:
% Dake, L.P., 1978: Fundamentals of reservoir engineering, Elsevier.
%
% JDJ, 13-02-11

A = 2.4e-6;
B = 1.1;
beta = A * k^-B;
