% Script file example_survey
%
% Example to open a text file containing a wellbore survey, evaluate the survey and create a
% plot. 
%
% ahd = along-hole depth (m)
% inc = inclination (rad)
% azi = azimuth (rad)
% nor = northing (m)
% eas = easting (m)
% tvd = true-vertical depth (m)
%
% JDJ, 10-09-04, last revised 29-05-17

clear variables
close all

fid = fopen('deviated_well_01.txt'); % file identifier
[ahd,inc,azi,nor,eas,tvd] = evaluate_survey(fid);

fclose(fid);

plot_survey(nor,eas,tvd)
