function theta = from_alpha_to_theta(alpha) 
% function theta = from_alpha_to_theta(alpha) 
%
% Converts an inclination wrt. vertical, as used in well engineering to an inclination w.r.t.
% horizontal as used in pipeline engineering      
%
% alpha = inclination wrt. vertical, rad
% theta = inclination wrt. horizontal, rad, where a positive value
%         indicates an increasing flow line elevation, seen from the
%         manifold.  
% 
% JDJ, 20-09-04, last revised 27-08-12

theta = alpha - pi/2;
