function alpha = from_theta_to_alpha(theta) 
% function alpha = from_theta_to_alpha(theta) 
%
% Converts an inclination wrt. horizontal, as used in pipeline engineering to an inclination
% w.r.t. vertical as used in well engineering     
%
% alpha = inclination wrt. vertical, rad
% theta = inclination wrt. horizontal, rad, where a positive value
%         indicates an increasing flow line elevation, seen from the
%         manifold.  
% 
% JDJ, 20-09-04, last revised 27-08-12

alpha = pi/2 + theta;
